/*
 *	Copyright (C) Performance Awareness Corporation, 1993, 1994, 1995
 *	ALL RIGHTS RESERVED WORLDWIDE.
 *
 *	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF
 *	Performance Awareness Corporation
 *	and should be treated as Confidential.
 *
 *	The copyright notice above does not evidence any
 *	actual or intended publication of such source code.
 *
 *	preVue and preVue-X are trademarks of Performance Awareness Corporation.
 */
/*
	.../preVue/include/sme/loadproc.h         (formatted 4 spaces per tab)
	
	This header file is included with the preVue-X product as an unsupported
	tool.  Although it is provided primarily for the use of Performance
	Awareness Corporation Subject Matter Experts, it may be used by any
	preVue-X licensee.  Use of the file is solely at the risk and discretion
	of the user, and Performance Awareness Corporation does not support this
	routine as part of the customer support and/or maintenance agreements.
	
	This header includes an inline procedure for building the load script.  
	It is designed for use with the loaddef.h header file that contains
	the variable declarations, macro defines, and supporting procedures. These
	two header files are designed to be used for creating the workload models
	described in the SME Handbook.  See the Methodology & Toolkit sections
	of that document for a full description of their use.
*/                                                          
#ifndef	_PV_EXIT_CHECK_FREQUENCY
#define	_PV_EXIT_CHECK_FREQUENCY	SECONDS(30)
#endif

#ifndef	_PV_LOAD_CHECK_FREQUENCY
#define	_PV_LOAD_CHECK_FREQUENCY	SECONDS(30)
#endif

	while (!wait(&load_sync,0,0,1,_PV_EXIT_CHECK_FREQUENCY))
		{
		if (exit_flag)			/* should we exit? */
			{
			task_exit("exit_flag was set!");
			}
		}
    
/*
	Check the test length to see if the specified interval has been
	exceeded.  If not, check the workload by calling the user supplied
	compute_load() function.  The function should return non-zero only 
	if there is work to be done.
*/

	while (!exit_flag)
		{
		if (time_limit && ((time()-base_time) >= MINUTES(time_limit)))
			{
			exit_flag = 1;
			}
		else if (compute_load())
			{
			break;
			}
		delay(_PV_LOAD_CHECK_FREQUENCY);
		}
		
	load_sync--;
